import java.awt.*;
import java.awt.event.*;
import java.util.*;
import com.sun.java.swing.*;
//import javax.swing.*;
//import javax.swing.border.*;
import java.io.*;


public class IntlIconMenus1a extends JFrame
{
    boolean[] flg;
    
    public JMenuItem jx[];
    public JSeparator separatorArray1[];
    public JSeparator separatorArray2[];
    public JSeparator separatorArray3[];
    public JSeparator separatorArray4[];
    public JMenuItem countryFlagMenu2Items[];
    public JMenuItem countryFlagMenu3Items[];
    public JMenuItem countryFlagMenu1Items[];
    public ImageIcon imageIcon1[];
    public ImageIcon imageIcon2[];
    public ImageIcon imageIcon3[];
    public ImageIcon imageIcon4[];
    

    public JTextArea imgDisplay;
    public int saveJxxx;//the index of the country menuItem to call IntlWordsMenus()

	public IntlIconMenus1a(boolean flg[]) 
	{
	    this.flg = flg;
	    String language = "en";
	    String country = "US";
	    Locale currentLocale, setupLocale, iconGraphicsLocale;
	    ResourceBundle messages, setupMessages,iconGraphics;
	    
	    setupLocale = new Locale("Checkbox", "Countries");
	    currentLocale = new Locale(language, country);
	    messages = ResourceBundle.getBundle("MessagesBundle", currentLocale);
	    setupMessages = ResourceBundle.getBundle("MessagesBundle", setupLocale);
	    
	    iconGraphicsLocale = new Locale("IconMenus", "GRAPHICS");
	    iconGraphics = ResourceBundle.getBundle("MessagesBundle", iconGraphicsLocale);

		
		//setJMenuBar(JMenuBar1);
		setTitle("SignWriter 5.0");
		setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
		getContentPane().setLayout(new BorderLayout());
		setSize(799,600);

		//*********************** Panel2 Pieces ********************************************************
		//icons for labels over the various menus
 		ImageIcon overFileMenuMenuIcon              = new ImageIcon(iconGraphics.getString("fileMenuTitle"));
 		ImageIcon overEditMenuMenuIcon              = new ImageIcon(iconGraphics.getString("editMenuTitle"));
 		ImageIcon overMenusMenuMenuIcon             = new ImageIcon(iconGraphics.getString("menusMenuTitle"));
 		ImageIcon overTypeSignsMenuIcon             = new ImageIcon(iconGraphics.getString("signsMenuTitle"));
 		ImageIcon overTypeFingerspellingMenuIcon    = new ImageIcon(iconGraphics.getString("fingerspellingMenuTitle"));
 		ImageIcon overTypeWordsMenuIcon             = new ImageIcon(iconGraphics.getString("typeWordsMenuTitle"));
 		ImageIcon overDictionariesMenuIcon          = new ImageIcon(iconGraphics.getString("dictionariesMenuTitle"));
		ImageIcon overFontsMenuIcon                 = new ImageIcon(iconGraphics.getString("fontsMenuTitle"));
 		ImageIcon overHelpMenuIcon                  = new ImageIcon(iconGraphics.getString("helpMenuTitle"));

        //labels for the various menus to put on Panel2
        JLabel overFileMenuLabel                = new JLabel(overFileMenuMenuIcon);
        JLabel overEditMenuLabel                = new JLabel(overEditMenuMenuIcon);
        JLabel overMenusMenuLabel               = new JLabel(overMenusMenuMenuIcon);
		JLabel overTypeSignsMenuLabel           = new JLabel(overTypeSignsMenuIcon);
		JLabel overTypeFingerspellingMenuLabel  = new JLabel(overTypeFingerspellingMenuIcon);
		JLabel overTypeWordsMenuLabel           = new JLabel(overTypeWordsMenuIcon);
		JLabel overDictionariesMenuLabel        = new JLabel(overDictionariesMenuIcon);
        JLabel overFontsMenuLabel               = new JLabel(overFontsMenuIcon);
		JLabel overHelpMenuLabel                = new JLabel(overHelpMenuIcon);
		//*********************** Panel2 Pieces ********************************************************
        
		//put labels over the various menus
		JPanel2.add(overFileMenuLabel);
		JPanel2.add(overEditMenuLabel);
		JPanel2.add(overMenusMenuLabel);
		JPanel2.add(overTypeSignsMenuLabel);
		JPanel2.add(overTypeFingerspellingMenuLabel);
		JPanel2.add(overTypeWordsMenuLabel);
		JPanel2.add(overDictionariesMenuLabel);
		JPanel2.add(overDictionariesMenuLabel);
		JPanel2.add(overFontsMenuLabel);
		JPanel2.add(overHelpMenuLabel);
		//*********************** Panel Pieces ********************************************************

		//*****JPanel1.setBounds(0,0,488,309);
        JPanel1.add(JMenuBar1);

		//*********************** Menu Pieces ********************************************************
        //icons for file menu items
    	ImageIcon newIcon       = new ImageIcon(iconGraphics.getString("fileMenuItemNew"));
	    ImageIcon openIcon      = new ImageIcon(iconGraphics.getString("fileMenuItemOpen"));
    	ImageIcon saveIcon      = new ImageIcon(iconGraphics.getString("fileMenuItemSave"));
    	ImageIcon saveAsIcon    = new ImageIcon(iconGraphics.getString("fileMenuItemSaveAs"));
    	ImageIcon printIcon     = new ImageIcon(iconGraphics.getString("fileMenuItemPrint"));
    	ImageIcon exitIcon      = new ImageIcon(iconGraphics.getString("fileMenuItemExit"));
    	
    	//icons for edit menu items
    	ImageIcon undoIcon      = new ImageIcon(iconGraphics.getString("editMenuItemUndo"));
    	ImageIcon cutIcon       = new ImageIcon(iconGraphics.getString("editMenuItemCut"));
    	ImageIcon copyIcon      = new ImageIcon(iconGraphics.getString("editMenuItemCopy"));
    	ImageIcon pasteIcon     = new ImageIcon(iconGraphics.getString("editMenuItemPaste"));
    	ImageIcon deleteIcon    = new ImageIcon(iconGraphics.getString("editMenuItemDelete"));
    	ImageIcon selectAllIcon = new ImageIcon(iconGraphics.getString("editMenuItemSelectAll"));
    	
    	//icons for menus menu items
 		ImageIcon menusInIconsIcon              = new ImageIcon(iconGraphics.getString("menusMenuItemMenusinIcons"));
 		ImageIcon menusInSignsIcon              = new ImageIcon(iconGraphics.getString("menusMenuItemMenusinSigns"));
 		ImageIcon menusInWordsIcon              = new ImageIcon(iconGraphics.getString("menusMenuItemMenusinWords"));
 		ImageIcon menusInSignsAndWordsIcon      = new ImageIcon(iconGraphics.getString("menusMenuItemMenusinSigns&Words"));
 		ImageIcon menusInIconsAndWordsIcon      = new ImageIcon(iconGraphics.getString("menusMenuItemMenusinIcons&Words"));
 		ImageIcon menusInSignsAndIconsIcon      = new ImageIcon(iconGraphics.getString("menusMenuItemMenusinSigns&Icons"));
 		ImageIcon menusInColorIcon              = new ImageIcon(iconGraphics.getString("menusMenuItemMenusinColor"));

    	//icons for type signs menu items
    	ImageIcon signsMenuItemDownColLRIcon     = new ImageIcon(iconGraphics.getString("signsMenuItemDownColL-R"));
    	ImageIcon signsMenuItemDownColRLIcon     = new ImageIcon(iconGraphics.getString("signsMenuItemDownColR-L"));
    	ImageIcon signsMenuItemAcrossLRIcon      = new ImageIcon(iconGraphics.getString("signsMenuItemAcrossL-R"));
    	ImageIcon signsMenuItemAcrossRLIcon      = new ImageIcon(iconGraphics.getString("signsMenuItemAcrossR-L"));
    	ImageIcon signsMenuItemOtherPatternsIcon = new ImageIcon(iconGraphics.getString("signsMenuItemOtherPatterns"));
       
        //type signs menu items
        signsMenuItemDownColLRItem.setIcon(signsMenuItemDownColLRIcon);
		signsMenuItemDownColRLItem.setIcon(signsMenuItemDownColRLIcon);
		signsMenuItemAcrossLRItem.setIcon(signsMenuItemAcrossLRIcon);
		signsMenuItemAcrossRLItem.setIcon(signsMenuItemAcrossRLIcon);
		signsMenuItemOtherPatternsItem.setIcon(signsMenuItemOtherPatternsIcon);
       
        //icons for fonts menu items fontsLargeItem 
        ImageIcon largeFontsIcon = new ImageIcon(iconGraphics.getString("fontsMenuItemLarge"));//	
        ImageIcon mediumFontsIcon = new ImageIcon(iconGraphics.getString("fontsMenuItemMedium"));//	
        ImageIcon smallFontsIcon = new ImageIcon(iconGraphics.getString("fontsMenuItemSmall"));//	
        ImageIcon boldFontsIcon = new ImageIcon(iconGraphics.getString("fontsMenuItemBold"));//	
        ImageIcon italicFontsIcon = new ImageIcon(iconGraphics.getString("fontsMenuItemItalic"));//	
        ImageIcon colorSymbolsFontsIcon = new ImageIcon(iconGraphics.getString("fontsMenuItemColorSymbols"));//	
 
    	
    	//icons for help menu items
    	ImageIcon lessonsInSignWritingIcon = new ImageIcon(iconGraphics.getString("helpMenuItemLessonsInSignWriting"));
    	ImageIcon lessonsInSignWriterIcon = new ImageIcon(iconGraphics.getString("helpMenuItemLessonsInSignWriter"));
    	ImageIcon aboutSignWriterIcon = new ImageIcon(iconGraphics.getString("helpMenuItemAboutSignWriter"));
    	ImageIcon technicalSupportIcon = new ImageIcon(iconGraphics.getString("helpMenuItemTechnicalSupport"));
		//*********************** Menu Pieces ********************************************************

		JPanel2.setLayout(new FlowLayout(FlowLayout.LEFT,10,10));
		getContentPane().add("North", JPanel2);
		JPanel2.setBounds(0,0,50,29);

		//add goToConfigButton to panel1
		goToConfigButton.setText("Setup");
		goToConfigButton.setBackground(Color.lightGray);
		goToConfigButton.setForeground(new Color(64,164,189));
        JPanel1.add(goToConfigButton);
        
        //add panel1 to display
		getContentPane().add("West", JPanel1);
		
		//file menu &&&&&&&&&&&&&&&&&&&&&&&&&&&
		saveFileDialog.setMode(FileDialog.LOAD);
		    //$$ saveFileDialog.move(24,336);
		openFileDialog.setMode(FileDialog.LOAD);
		    //$$ openFileDialog.move(0,336);
		saveFileDialog.setMode(FileDialog.SAVE);
		saveFileDialog.setTitle("Save");
		    //$$ saveFileDialog.move(24,336);
		openFileDialog.setMode(FileDialog.LOAD);
		openFileDialog.setTitle("Open");
		    //$$ openFileDialog.move(0,336);
		
		String xfile = messages.getString("fileMenuTitle");
		fileMenu.setText("  " + xfile);
		fileMenu.setActionCommand("File");
		fileMenu.setMnemonic((int)'1');//'F');
		JMenuBar1.add(fileMenu);
		//JMenuBar1.setBackground(Color.lightGray);
		//fileMenu.setBackground(Color.gray);
		
		//
		newItem.setIcon(newIcon);
		    //newItem.setHorizontalTextPosition(SwingConstants.RIGHT);
		    //newItem.setText("New");
		    //newItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_N, Event.CTRL_MASK));
		newItem.setActionCommand("New");
		newItem.setMnemonic((int)'N');
		fileMenu.add(newItem);
		fileMenu.add(JSeparator1);
		
		//
		openItem.setIcon(openIcon);
		    //openItem.setHorizontalTextPosition(SwingConstants.RIGHT);
		    //openItem.setText("Open...");
		    //openItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_O, Event.CTRL_MASK));
		openItem.setActionCommand("Open...");
		openItem.setMnemonic((int)'O');
		fileMenu.add(openItem);
        fileMenu.add(JSeparator2);
        
        //
		saveItem.setIcon(saveIcon);
		    //saveItem.setHorizontalTextPosition(SwingConstants.RIGHT);
		    //saveItem.setText("Save");
    	saveItem.setMnemonic((int)'S');
		saveItem.setActionCommand("Save");
	    fileMenu.add(saveItem);
        fileMenu.add(JSeparator3);

		//
	    saveAsItem.setIcon(saveAsIcon);
		    //saveAsItem.setText("Save As...");
		    //saveAsItem.setText("Save As...");
		saveAsItem.setActionCommand("Save As...");
		saveAsItem.setMnemonic((int)'A');
		fileMenu.add(saveAsItem);
        fileMenu.add(JSeparator4);
		    
		//
		printItem.setActionCommand("Print");
        printItem.setIcon(printIcon);
		//saveAsItem.setMnemonic((int)'A');
		//fileMenu.add(saveAsItem);//visualFileMenuSaveAsItem
		fileMenu.add(printItem);//fileMenuPrintLabel);
		//fileMenu.add(grayBarFileMenuItem3);
		fileMenu.add(JSeparator5);

		//
		exitItem.setIcon(exitIcon);
		//exitItem.setText("Exit");
		exitItem.setActionCommand("Exit");
		exitItem.setMnemonic((int)'X');
		fileMenu.add(exitItem);
		//fileMenu &&&&&&&&&&&&&&&&&&&&&&&&&&&

		
		//editMenu &&&&&&&&&&&&&&&&&&&&&&&&&&&
		editMenu.setText(messages.getString("editMenuTitle"));
		editMenu.setActionCommand("Edit");
		editMenu.setMnemonic((int)'2');//'E');
		JMenuBar1.add(editMenu);
		//
		cutItem.setIcon(cutIcon);
		    //cutItem.setHorizontalTextPosition(SwingConstants.RIGHT);
		    //cutItem.setText("Cut");
		cutItem.setActionCommand("Cut");
		    //cutItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_X, Event.CTRL_MASK));
		    //cutItem.setMnemonic((int)'T');
		editMenu.add(cutItem);
		editMenu.add(JSeparator6);
		//
		copyItem.setIcon(copyIcon);
		    //copyItem.setHorizontalTextPosition(SwingConstants.RIGHT);
		    //copyItem.setText("Copy");
		copyItem.setActionCommand("Copy");
		    //copyItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_C, Event.CTRL_MASK));
		    //copyItem.setMnemonic((int)'C');
		editMenu.add(copyItem);
		editMenu.add(JSeparator7);
		//
		pasteItem.setIcon(pasteIcon);
		    //pasteItem.setHorizontalTextPosition(SwingConstants.RIGHT);
		    //pasteItem.setText("Paste");
		pasteItem.setActionCommand("Paste");
		    //pasteItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_V, Event.CTRL_MASK));
		    //pasteItem.setMnemonic((int)'P');
	    editMenu.add(pasteItem);
		editMenu.add(JSeparator8);
        //
		deleteItem.setIcon(deleteIcon);
		    //pasteItem.setHorizontalTextPosition(SwingConstants.RIGHT);
		    //pasteItem.setText("Paste");
		deleteItem.setActionCommand("Delete");
		    //pasteItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_V, Event.CTRL_MASK));
		    //pasteItem.setMnemonic((int)'P');
	    editMenu.add(deleteItem);
		editMenu.add(JSeparator9);
		//
		selectAllItem.setIcon(selectAllIcon);
		    //pasteItem.setHorizontalTextPosition(SwingConstants.RIGHT);
		    //pasteItem.setText("Paste");
		selectAllItem.setActionCommand("SelectAll");
		    //pasteItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_V, Event.CTRL_MASK));
		    //pasteItem.setMnemonic((int)'P');
	    editMenu.add(selectAllItem);
        //editMenu &&&&&&&&&&&&&&&&&&&&&&&&&&&		
		
		//
	    JMenu menusInWordsMenu = new JMenu();
//****************     menusInWordsItem.setIcon(menusInWordsIcon);
        menusInWordsMenu.setIcon(menusInWordsIcon);
        //need a flag submenu to put on menusInWordsItem
 	    JMenu countryFlagMenu4 = new JMenu();
         //keep this just after editMenu for room
	    JMenu menusMenu1 = new JMenu();
	    menusMenu1.setText(messages.getString("menusMenuTitle"));
		menusMenu1.setMnemonic((int)'3');//'M');
	    menusMenu1.add(menusInSignsMenu);
		menusMenu1.add(JSeparator10);
        menusMenu1.add(menusInWordsMenu);
		menusMenu1.add(JSeparator11);
	    menusMenu1.add(menusInSignsAndWordsMenu);
		menusMenu1.add(JSeparator12);

//*****************************************************************
//*** create menuItems and load with info from messagesBundle ***//
//***
		SymAction lSymAction = new SymAction();
           
        String img;
        String icon;
        String itemIntegerSpacing;
        String imgx = "";

        imgDisplay = new JTextArea();
        //getContentPane().add(imgDisplay);
		imgDisplay.setBounds(62,517,377,24);

        Vector menuItems = new Vector(51);

        //create some menus
 	    JMenu countryFlagMenu2 = new JMenu();//fingerSpelling
 	    JMenu countryFlagMenu3 = new JMenu();//words
 	    JMenu countryFlagMenu1 = new JMenu();//dictionaries
        
        //create the menuItems arrays
        jx = new JMenuItem[51];
        separatorArray1 = new JSeparator[51];
        separatorArray2 = new JSeparator[51];
        separatorArray3 = new JSeparator[51];
        separatorArray4 = new JSeparator[51];

        //
        //typeFingerspellingWordsMenu1Items = new JMenuItem[51];
        countryFlagMenu2Items = new JMenuItem[51];
        
        //typeWordsWordsmenu1Items = new JMenuItem[51];
        countryFlagMenu3Items = new JMenuItem[51];
        
        //signDictionariesWordsMenu1Items = new JMenuItem[51];
        countryFlagMenu1Items = new JMenuItem[51];

           //
           //make ImageIcon arrays
           imageIcon1 = new ImageIcon[51];
           imageIcon2 = new ImageIcon[51];
           imageIcon3 = new ImageIcon[51];
           imageIcon4 = new ImageIcon[51];
           for(int k = 1; k < 51; k++)
           {
              //create strings to use in retreiving info from messagesBundle
              country = "country" + Integer.toString(k);
              img = "image" + Integer.toString(k);
              icon = "image" + Integer.toString(k) + "Icon";
              imageIcon1[k] = new ImageIcon(setupMessages.getString(img));
	          jx[k] = new JMenuItem(setupMessages.getString(country),imageIcon1[k]);
              //typeFingerspellingWordsMenu1Items = new JMenuItem[51];
              imageIcon2[k] = new ImageIcon(setupMessages.getString(img));
              countryFlagMenu2Items[k] = new JMenuItem(setupMessages.getString(country),imageIcon2[k]);
              //typeWordsWordsmenu1Items = new JMenuItem[51];
              imageIcon3[k] = new ImageIcon(setupMessages.getString(img));
              countryFlagMenu3Items[k] = new JMenuItem(setupMessages.getString(country),imageIcon3[k]);
              //signDictionariesWordsMenu1Items = new JMenuItem[51];
              imageIcon4[k] = new ImageIcon(setupMessages.getString(img));
              countryFlagMenu1Items[k] = new JMenuItem(setupMessages.getString(country),imageIcon4[k]);

              separatorArray1[k] = new JSeparator();
              separatorArray2[k] = new JSeparator();
              separatorArray3[k] = new JSeparator();
              separatorArray4[k] = new JSeparator();

    //But if MessagesBundle_language_country.properties
		        String languageK = "code"  + "l" + Integer.toString(k);
		        String countryK = "code"  + "c" + Integer.toString(k);

                String checkFileExists = "MessagesBundle_" + (setupMessages.getString(languageK )) + "_" + (setupMessages.getString(countryK)) + ".properties";
                File f = new File( checkFileExists );
		    

                //****** for debugging
                if(!( f.exists()))
                {
                    flg[k] = false;
                    displayProblem(k);
                    checkFileExists += "DOES NOT EXIST";
                    imgDisplay.append(checkFileExists);//.setText(checkFileExists);// + "DOES NOT XXX EXIST");
                }
                //********************
                

	          if(flg[k] == true)
	          {
	            menusInWordsMenu.add(jx[k]);
	            menusInWordsMenu.add(separatorArray1[k]);
	            countryFlagMenu2.add(countryFlagMenu2Items[k]);
	            countryFlagMenu2.add(separatorArray2[k]);
	            countryFlagMenu3.add(countryFlagMenu3Items[k]);
	            countryFlagMenu3.add(separatorArray3[k]);
	            countryFlagMenu1.add(countryFlagMenu1Items[k]);
	            countryFlagMenu1.add(separatorArray4[k]);
	          }
	          jx[k].addActionListener(lSymAction);
	          jx[k].setHorizontalTextPosition(SwingConstants.RIGHT);
	          
	          countryFlagMenu2Items[k].addActionListener(lSymAction);
	          countryFlagMenu2Items[k].setHorizontalTextPosition(SwingConstants.RIGHT);
	          
	          countryFlagMenu3Items[k].addActionListener(lSymAction);
	          countryFlagMenu3Items[k].setHorizontalTextPosition(SwingConstants.RIGHT);
	          
	          countryFlagMenu1Items[k].addActionListener(lSymAction);
	          countryFlagMenu1Items[k].setHorizontalTextPosition(SwingConstants.RIGHT);
	          
           }

	    //menusMenu1.add(menusInSignsAndWordsItem);
		//menusMenu1.add(JSeparator13);
	    menusMenu1.add(menusInIconsAndWordsItem);
		menusMenu1.add(JSeparator14);
	    menusMenu1.add(menusInSignsAndIconsItem);
		menusMenu1.add(JSeparator15);
	    menusMenu1.add(menusInColorItem);
		//
		//add it to the menuBar
		JMenuBar1.add(menusMenu1);


		//{{REGISTER_LISTENERS
		SymMouse aSymMouse = new SymMouse();
		goToConfigButton.addMouseListener(aSymMouse);
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		//SymAction lSymAction = new SymAction();
		openItem.addActionListener(lSymAction);
		saveItem.addActionListener(lSymAction);
		exitItem.addActionListener(lSymAction);
		aboutItem.addActionListener(lSymAction);
//*********			menusInWordsItem.addActionListener(lSymAction);


    //declare the ImageIcons    
    ImageIcon usaFlagIcon = new ImageIcon("images/USA.JPG");

    //
    //menusInIconsItem
    menusInIconsItem.setIcon(menusInIconsIcon);//item here rather than a menu		

    //menusInSignsMenu
	menusInSignsMenu.setIcon(menusInSignsIcon);
        usaSignsItem.setText("USA");  
	    usaSignsItem.setHorizontalTextPosition(SwingConstants.RIGHT);
        usaSignsItem.setIcon(usaFlagIcon);
        usaSignsItem.addActionListener(lSymAction);
    menusInSignsMenu.add(usaSignsItem);

    //menusInSignsAndWordsMenu
    menusInSignsAndWordsMenu.setIcon(menusInSignsAndWordsIcon);
         usaSignsItem2.setText("USA");
         usaSignsItem2.setHorizontalTextPosition(SwingConstants.RIGHT);
         usaSignsItem2.setIcon(usaFlagIcon);
         usaSignsItem2.addActionListener(lSymAction);
    menusInSignsAndWordsMenu.add(usaSignsItem2);
        
    //menusInIconsAndWords
    menusInIconsAndWordsItem.setIcon(menusInIconsAndWordsIcon);
    
    //menusInSignsAndIcons
    menusInSignsAndIconsItem.setIcon(menusInSignsAndIconsIcon);
    
    //menusInColor
    menusInColorItem.setIcon(menusInColorIcon);
		
    //
    JMenu typeSignsMenu1 = new JMenu();
	String xsign = messages.getString("signsMenuTitle");
	typeSignsMenu1.setText("  " + xsign);
		typeSignsMenu1.setMnemonic((int)'4');//'S');
        typeSignsMenu1.add(signsMenuItemDownColLRItem);
        typeSignsMenu1.add(JSeparator16);
        typeSignsMenu1.add(signsMenuItemDownColRLItem);
        typeSignsMenu1.add(JSeparator17);
        typeSignsMenu1.add(signsMenuItemAcrossLRItem);
        typeSignsMenu1.add(JSeparator18);
        typeSignsMenu1.add(signsMenuItemAcrossRLItem);
		JMenuBar1.add(typeSignsMenu1);
        //
		String xfinger = messages.getString("fingerspellingMenuTitle");
		countryFlagMenu2.setText("         " + xfinger);

		countryFlagMenu2.setMnemonic((int)'5');//'G');
		JMenuBar1.add(countryFlagMenu2);
	    
	    countryFlagMenu3.setText("      " + messages.getString("wordsMenuTitle"));//("Type Words");
		countryFlagMenu3.setMnemonic((int)'6');//'W');
		JMenuBar1.add(countryFlagMenu3);
 
	    countryFlagMenu1.setText("        " + messages.getString("dictionariesMenuTitle"));//("  Dictionaries");
		countryFlagMenu1.setMnemonic((int)'7');//'D');
		JMenuBar1.add(countryFlagMenu1);

        //fonts menu
	    JMenu fontsMenu1 = new JMenu();
	    fontsMenu1.setText("    Fonts");
		fontsMenu1.setMnemonic((int)'8');//'T');
        //
		fontsLargeItem.setIcon(largeFontsIcon);
		fontsMediumItem.setIcon(mediumFontsIcon);
		fontsSmallItem.setIcon(smallFontsIcon);
		fontsItalicItem.setIcon(italicFontsIcon);
		fontsBoldItem.setIcon(boldFontsIcon);
		fontsColorSymbolsItem.setIcon(colorSymbolsFontsIcon);
        //
        fontsMenu1.add(fontsLargeItem);
	        fontsMenu1.add(JSeparator19);
	    fontsMenu1.add(fontsMediumItem);
            fontsMenu1.add(JSeparator20);	    
	    fontsMenu1.add(fontsSmallItem);
	        fontsMenu1.add(JSeparator21);
	    fontsMenu1.add(fontsItalicItem);
	        fontsMenu1.add(JSeparator22);
	    fontsMenu1.add(fontsBoldItem);
    	    fontsMenu1.add(JSeparator23);
	    fontsMenu1.add(fontsColorSymbolsItem);
        //
		JMenuBar1.add(fontsMenu1);
        
		// helpMenu
        //items for help menu
		lessonsInSignWritingItem.setIcon(lessonsInSignWritingIcon);
		lessonsInSignWriterItem.setIcon(lessonsInSignWriterIcon);
		aboutSignWriterItem.setIcon(aboutSignWriterIcon);
		technicalSupportItem.setIcon(technicalSupportIcon);
        //
		helpMenu.setText("     " + messages.getString("helpMenuTitle"));
		helpMenu.setActionCommand("Help");
		helpMenu.setMnemonic((int)'9');//'H');
		JMenuBar1.add(helpMenu);
		//add ITEMS to help menu
		helpMenu.add(lessonsInSignWritingItem);
		helpMenu.add("SignWriting");
		helpMenu.add(JSeparator24);
		helpMenu.add(lessonsInSignWriterItem);
		helpMenu.add("SignWriter");
		helpMenu.add(JSeparator25);
		//aboutItem.setIcon(aboutIcon);
		aboutSignWriterItem.setHorizontalTextPosition(SwingConstants.RIGHT);
		aboutSignWriterItem.setText("About...");
		aboutSignWriterItem.setActionCommand("About...");
		aboutSignWriterItem.setMnemonic((int)'A');
		helpMenu.add(aboutSignWriterItem);
        helpMenu.add(JSeparator26);
        helpMenu.add(technicalSupportItem);
		
    this.setVisible(true);
		
}

    /**
     * Notifies this component that it has been added to a container
     * This method should be called by <code>Container.add</code>, and 
     * not by user code directly.
     * Overridden here to adjust the size of the frame if needed.
     * @see java.awt.Container#removeNotify
     */
	public void addNotify()
	{
		// Record the size of the window prior to calling parents addNotify.
		Dimension size = getSize();
		
		super.addNotify();
		
		if (frameSizeAdjusted)
			return;
		frameSizeAdjusted = true;
		
		// Adjust size of frame according to the insets and menu bar
		JMenuBar menuBar = getRootPane().getJMenuBar();
		int menuBarHeight = 0;
		if (menuBar != null)
		    menuBarHeight = menuBar.getPreferredSize().height;
		Insets insets = getInsets();
		setSize(insets.left + insets.right + size.width, insets.top + insets.bottom + size.height + menuBarHeight);
	}//method

	// Used by addNotify
	boolean frameSizeAdjusted = false;

    //
	FileDialog saveFileDialog = new FileDialog(this);
	FileDialog openFileDialog = new FileDialog(this);
	
	JPanel JPanel1 = new JPanel();
	JPanel JPanel2 = new JPanel();
	JMenuBar JMenuBar1 = new JMenuBar();
	JToolBar JToolBar1 = new JToolBar();

	JButton goToConfigButton = new JButton();
	
	//file menu
	JMenu fileMenu = new JMenu();
	 JMenuItem newItem = new JMenuItem();
	 JMenuItem openItem = new JMenuItem();
	 JMenuItem saveItem = new JMenuItem();
	 JMenuItem saveAsItem = new JMenuItem();
	 JMenuItem printItem = new JMenuItem();
     JMenuItem exitItem = new JMenuItem();
     
	//edit mneu
	JMenu editMenu = new JMenu();
	 JMenuItem cutItem = new JMenuItem();
	 JMenuItem copyItem = new JMenuItem();
	 JMenuItem pasteItem = new JMenuItem();
	 JMenuItem selectAllItem = new JMenuItem();
	 JMenuItem deleteItem = new JMenuItem();
	
	JMenu helpMenu = new JMenu();
	 JMenuItem aboutItem = new JMenuItem();
    
    // menusInSignsAndIconsItem   
	JMenuItem menusInIconsItem = new JMenuItem();
    JMenu menusInSignsMenu = new JMenu();
    JMenu menusInSignsAndWordsMenu = new JMenu();

	JMenuItem menusInSignsItem = new JMenuItem();
	JMenuItem usaSignsItem = new JMenuItem();
	JMenuItem usaSignsItem2 = new JMenuItem();
	JMenuItem usaSignsItem3 = new JMenuItem();
	
	//menus menu items
//*********	JMenuItem menusInWordsItem = new JMenuItem();
	JMenuItem menusInSignsAndWordsItem = new JMenuItem();
	JMenuItem menusInIconsAndWordsItem = new JMenuItem();
	JMenuItem menusInSignsAndIconsItem = new JMenuItem();
	JMenuItem menusInColorItem = new JMenuItem();
    
	//type signs menu items
	JMenuItem signsMenuItemDownColLRItem = new JMenuItem();
	JMenuItem signsMenuItemDownColRLItem = new JMenuItem();
	JMenuItem signsMenuItemAcrossLRItem = new JMenuItem();
	JMenuItem signsMenuItemAcrossRLItem = new JMenuItem();
	JMenuItem signsMenuItemOtherPatternsItem = new JMenuItem();

	//fonts menu items
	JMenuItem fontsLargeItem = new JMenuItem();
	JMenuItem fontsMediumItem = new JMenuItem();
	JMenuItem fontsSmallItem = new JMenuItem();
	JMenuItem fontsItalicItem = new JMenuItem();
	JMenuItem fontsBoldItem = new JMenuItem();
	JMenuItem fontsColorSymbolsItem = new JMenuItem();
    
    //help menu items
	JMenuItem lessonsInSignWritingItem = new JMenuItem();
	JMenuItem lessonsInSignWriterItem = new JMenuItem();
	JMenuItem aboutSignWriterItem = new JMenuItem();
	JMenuItem technicalSupportItem = new JMenuItem();

    //signs menu stuff 
    JMenu menusInASLSignsMenu = new JMenu();
    JMenuItem menusInASLSigns1aMenuItem = new JMenuItem();
    //
	JMenu countryFlagMenu = new JMenu();
	JMenu countryFlagMenu2 = new JMenu();
	JMenu countryFlagMenu3 = new JMenu();
	//}}

    //create menu item separators	
	JSeparator JSeparator1 = new JSeparator();
	JSeparator JSeparator2 = new JSeparator();
	JSeparator JSeparator3 = new JSeparator();
	JSeparator JSeparator4 = new JSeparator();
	JSeparator JSeparator5 = new JSeparator();
	JSeparator JSeparator6 = new JSeparator();
	JSeparator JSeparator7 = new JSeparator();
	JSeparator JSeparator8 = new JSeparator();
	JSeparator JSeparator9 = new JSeparator();
	JSeparator JSeparator10 = new JSeparator();
	JSeparator JSeparator11 = new JSeparator();
	JSeparator JSeparator12 = new JSeparator();
	JSeparator JSeparator13 = new JSeparator();
	JSeparator JSeparator14 = new JSeparator();
	JSeparator JSeparator15 = new JSeparator();
	JSeparator JSeparator16 = new JSeparator();
	JSeparator JSeparator17 = new JSeparator();
	JSeparator JSeparator18 = new JSeparator();
	JSeparator JSeparator19 = new JSeparator();
	JSeparator JSeparator20 = new JSeparator();
	JSeparator JSeparator21 = new JSeparator();
	JSeparator JSeparator22 = new JSeparator();
	JSeparator JSeparator23 = new JSeparator();
	JSeparator JSeparator24 = new JSeparator();
	JSeparator JSeparator25 = new JSeparator();
	JSeparator JSeparator26 = new JSeparator();
	JSeparator JSeparator27 = new JSeparator();
	JSeparator JSeparator28 = new JSeparator();
	JSeparator JSeparator29 = new JSeparator();
	JSeparator JSeparator30 = new JSeparator();
    //*****************end menu pieces ***************

	void exitApplication()
	{
		try {
	    	// Beep
	    	Toolkit.getDefaultToolkit().beep();
	    	// Show a confirmation dialog
	    	int reply = JOptionPane.showConfirmDialog(this, 
	    	                                          "Do you really want to exit?", 
	    	                                          "         SignWriter 5.0 - Exit" , 
	    	                                          JOptionPane.YES_NO_OPTION, 
	    	                                          JOptionPane.QUESTION_MESSAGE);
			// If the confirmation was affirmative, handle exiting.
			if (reply == JOptionPane.YES_OPTION)
			{
		    	this.setVisible(false);    // hide the Frame
		    	this.dispose();            // free the system resources
		    	System.exit(0);            // close the application
			}
		} catch (Exception e) {}
	}//method
	

	class SymMouse extends MouseAdapter
	{
		public void mouseReleased(MouseEvent event)
		{
			Object object = event.getSource();
			if (object == goToConfigButton)
				goToConfigButton_MouseReleased(event);
		}
	}//class

	void goToConfigButton_MouseReleased(MouseEvent event)
	{
		// to do: code goes here.
			 
		goToConfigButton_MouseReleased_Interaction1(event);
	}//method

	void goToConfigButton_MouseReleased_Interaction1(MouseEvent event)
	{
		try {
			this.removeAll();
			new After1stTimeSetup(flg).setVisible(true);
			this.dispose();
		} catch (Exception e) {
		}
	}//method
//}
	

	class SymWindow extends WindowAdapter
	{
		public void windowClosing(WindowEvent event)
		{
			Object object = event.getSource();
			if (object == IntlIconMenus1a.this)
				IntlIconMenus1a_windowClosing(event);
		}
	}//class

	void IntlIconMenus1a_windowClosing(WindowEvent event)
	{
		// to do: code goes here.
			 
		IntlIconMenus1a_windowClosing_Interaction1(event);
	}

	void IntlIconMenus1a_windowClosing_Interaction1(WindowEvent event) {
		try {
			this.exitApplication();
		} catch (Exception e) {
		}
	}

	class SymAction implements ActionListener
	{
		public void actionPerformed(ActionEvent event)
		{
			Object object = event.getSource();
			for(int ii = 1; ii < 51; ii++)
			{
			    if (object == jx[ii])//jx is a menu item
			    {
			        //save the index of the country menuItem that was chosen
			        saveJxxx = ii;
			        //call the method to deal with the choice
			        jx_actionPerformed(event);
                }			    
			}
			if (object == openItem)
				openItem_actionPerformed(event);
			else if (object == saveItem)
				saveItem_actionPerformed(event);
			else if (object == exitItem)
				exitItem_actionPerformed(event);
			else if (object == aboutItem)
				aboutItem_actionPerformed(event);
			else if (object == menusInASLSigns1aMenuItem)
				menusInASLSigns1aMenuItem_actionPerformed(event);
			else if (object == usaSignsItem)
				usaSignsItem_actionPerformed(event);
			else if (object == usaSignsItem2)
				usaSignsItem2_actionPerformed(event);
		}
	}

	void jx_actionPerformed(ActionEvent event)
	{

	    Locale setupLocale;
	    ResourceBundle setupMessages;
	    
	    setupLocale = new Locale("Checkbox", "Countries");
	    setupMessages = ResourceBundle.getBundle("MessagesBundle", setupLocale);
		

		for(int xx = 1; xx < 51; xx++)
		{
            //just chose a country/language from menusInWordsMenu, so 
		    //get the text off the checkbox that corresponds to the country just chosen
		    String jxxx = jx[saveJxxx].getText();
		    //imgDisplay.setText(jxxx + "\n");//check it
		    
		    //now, find the index to retrieve info from messagesBundle 
		    //by comparing text off checkbox w/country listed in messagesBundle
		    if( jxxx.equals(setupMessages.getString("country" + Integer.toString(xx))))
		    {
		        String lang = "code"  + "l" + Integer.toString(xx);
		        String cntry = "code"  + "c" + Integer.toString(xx);

                    this.removeAll();
                    //this.setVisible(false);
                    new IntlWordsMenus1a(flg, saveJxxx);
                    this.dispose();
		    }
		}
	}
	
	void usaSignsItem_actionPerformed(ActionEvent event)
	{
	    this.removeAll();
	    new MenusInASLSigns1a(flg);
	    this.dispose();
	}
	void usaSignsItem2_actionPerformed(ActionEvent event)
	{
	    this.removeAll();
	    new MenusInASLSignsAndWords1a(flg);
	    this.dispose();
	}
	
	void menusInASLSigns1aMenuItem_actionPerformed(ActionEvent event)
	{
	    this.removeAll();
	    new MenusInASLSigns1a(flg);
	    this.dispose();
	}

	void openItem_actionPerformed(ActionEvent event)
	{
		// to do: code goes here.
			 
		openItem_actionPerformed_Interaction1(event);
	}

	void openItem_actionPerformed_Interaction1(ActionEvent event) {
		try {
			// openFileDialog Show the FileDialog
			openFileDialog.setVisible(true);
		} catch (Exception e) {
		}
	}

	void saveItem_actionPerformed(ActionEvent event)
	{
		// to do: code goes here.
			 
		saveItem_actionPerformed_Interaction1(event);
	}

	void saveItem_actionPerformed_Interaction1(ActionEvent event) {
		try {
			// saveFileDialog Show the FileDialog
			saveFileDialog.setVisible(true);
		} catch (Exception e) {
		}
	}

	void exitItem_actionPerformed(ActionEvent event)
	{
		// to do: code goes here.
			 
		exitItem_actionPerformed_Interaction1(event);
	}

	void exitItem_actionPerformed_Interaction1(ActionEvent event) {
		try {
			this.exitApplication();
		} catch (Exception e) {
		}
	}

	void aboutItem_actionPerformed(ActionEvent event)
	{
		// to do: code goes here.
			 
		aboutItem_actionPerformed_Interaction1(event);
	}

	void aboutItem_actionPerformed_Interaction1(ActionEvent event) {
		try {
			// JAboutDialog Create with owner and show as modal
			{
				JAboutDialog JAboutDialog1 = new JAboutDialog(this);
				JAboutDialog1.setModal(true);
				JAboutDialog1.show();
			}
		} catch (Exception e) {
		}
	}

	void openButton_actionPerformed(ActionEvent event)
	{
		// to do: code goes here.
			 
		openButton_actionPerformed_Interaction1(event);
	}

	void openButton_actionPerformed_Interaction1(ActionEvent event) {
		try {
			// openFileDialog Show the FileDialog
			openFileDialog.setVisible(true);
		} catch (Exception e) {
		}
	}

	void saveButton_actionPerformed(ActionEvent event)
	{
		// to do: code goes here.
			 
		saveButton_actionPerformed_Interaction1(event);
	}

	void saveButton_actionPerformed_Interaction1(ActionEvent event) {
		try {
			// saveFileDialog Show the FileDialog
			saveFileDialog.setVisible(true);
		} catch (Exception e) {
		}
	}


	void aboutButton_actionPerformed(ActionEvent event)
	{
		// to do: code goes here.
			 
		aboutButton_actionPerformed_Interaction1(event);
	}


    void displayProblem(int k)
    {
	    Locale setupLocaleK = new Locale("Checkbox", "Countries");
	    ResourceBundle setupMessagesK = ResourceBundle.getBundle("MessagesBundle", setupLocaleK);
		        String languageK = "code"  + "l" + Integer.toString(k);
		        String countryK = "code"  + "c" + Integer.toString(k);


        String checkFileExists = "MessagesBundle_" + (setupMessagesK.getString(languageK )) + "_" + (setupMessagesK.getString(countryK)) + ".properties";
        checkFileExists += "DOES NOT EXIST";
        imgDisplay.append(checkFileExists);
        //.setText(checkFileExists);// + "DOES NOT XXX EXIST");
    }
	//
	void aboutButton_actionPerformed_Interaction1(ActionEvent event) {
		try {
			// JAboutDialog Create with owner and show as modal
			{
				JAboutDialog JAboutDialog1 = new JAboutDialog(this);
				JAboutDialog1.setModal(true);
				JAboutDialog1.show();
			}
		} catch (Exception e) {
		}
	}
}